PF-build.sh 62 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029103010311032103310341035103610371038103910401041104210431044104510461047104810491050105110521053105410551056105710581059106010611062106310641065106610671068106910701071107210731074107510761077107810791080108110821083108410851086108710881089109010911092109310941095109610971098109911001101110211031104110511061107110811091110111111121113111411151116111711181119112011211122112311241125112611271128112911301131113211331134113511361137113811391140114111421143114411451146114711481149115011511152115311541155115611571158115911601161116211631164116511661167116811691170117111721173117411751176117711781179118011811182118311841185118611871188118911901191119211931194119511961197119811991200120112021203120412051206120712081209121012111212121312141215121612171218121912201221122212231224122512261227122812291230123112321233123412351236
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 2.0.0-Build_57
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. # 03 May 2021, 3d-gussner, Add SIM atmega404
  151. # 17 Jun 2021, 3d-gussner, Update PF-build.sh to work after DRracer Remove FW version parsing PR
  152. # 17 Jun 2021, 3d-gussner, Save ELF files for FW3.10.1 debugging PRs
  153. # 17 Jun 2021, 3d-gussner, Add verbose_IDE to output more information during build
  154. # 17 Jun 2021, 3d-gussner, Change version to v2.0.0
  155. # 18 Jun 2021, 3d-gussner, Use atmega404 if extanded RAM or FLASH size are chosen
  156. # 18 Jun 2021, 3d-gussner, Remove MK404 copy of lang file as it has been fixed in MK404
  157. # 21 Jun 2021, 3d-gussner, Change atmega404 board flash argument to y
  158. # Use newer version of MK404-build.sh instead start the program
  159. #### Start check if OSTYPE is supported
  160. OS_FOUND=$( command -v uname)
  161. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  162. linux*)
  163. TARGET_OS="linux"
  164. ;;
  165. msys*|cygwin*|mingw*)
  166. # or possible 'bash on windows'
  167. TARGET_OS='windows'
  168. ;;
  169. nt|win*)
  170. TARGET_OS='windows'
  171. ;;
  172. *)
  173. TARGET_OS='unknown'
  174. ;;
  175. esac
  176. # Windows
  177. if [ $TARGET_OS == "windows" ]; then
  178. if [ $(uname -m) == "x86_64" ]; then
  179. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  180. Processor="64"
  181. elif [ $(uname -m) == "i386" ]; then
  182. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  183. Processor="32"
  184. else
  185. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  186. echo "Please refer to the notes of build.sh$(tput sgr0)"
  187. exit 1
  188. fi
  189. # Linux
  190. elif [ $TARGET_OS == "linux" ]; then
  191. if [ $(uname -m) == "x86_64" ]; then
  192. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  193. Processor="64"
  194. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  195. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  196. Processor="32"
  197. else
  198. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  199. echo "Please refer to the notes of build.sh$(tput sgr0)"
  200. exit 1
  201. fi
  202. else
  203. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  204. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  205. echo "Read the notes of build.sh$(tput sgr0)"
  206. exit 1
  207. fi
  208. sleep 2
  209. #### End check if OSTYPE is supported
  210. #### Prepare bash environment and check if wget, zip and other needed things are available
  211. # Check wget
  212. if ! type wget > /dev/null; then
  213. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  214. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  215. exit 2
  216. fi
  217. # Check for zip
  218. if ! type zip > /dev/null; then
  219. if [ $TARGET_OS == "windows" ]; then
  220. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  221. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  222. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  223. echo "Run git Bash under Administrator privilege and"
  224. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  225. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  226. exit 3
  227. elif [ $TARGET_OS == "linux" ]; then
  228. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  229. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  230. #sudo apt-get update && apt-get install zip
  231. exit 3
  232. fi
  233. fi
  234. # Check python ... needed during language build
  235. if ! type python > /dev/null; then
  236. if [ $TARGET_OS == "windows" ]; then
  237. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  238. exit 4
  239. elif [ $TARGET_OS == "linux" ]; then
  240. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  241. echo "As Python 2.x will not be maintained from 2020 please,"
  242. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  243. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  244. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  245. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  246. exit 4
  247. fi
  248. fi
  249. # Check gawk ... needed during language build
  250. if ! type gawk > /dev/null; then
  251. if [ $TARGET_OS == "linux" ]; then
  252. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  253. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  254. #sudo apt-get update && apt-get install gawk
  255. exit 5
  256. fi
  257. fi
  258. #### End prepare bash / Linux environment
  259. # Check for options/flags
  260. while getopts b:c:d:g:h:i:j:l:m:n:o:p:v:x:y:?h flag
  261. do
  262. case "${flag}" in
  263. b) build_flag=${OPTARG};;
  264. c) clean_flag=${OPTARG};;
  265. d) devel_flag=${OPTARG};;
  266. g) graphics_flag=${OPTARG};;
  267. h) help_flag=1;;
  268. i) IDE_flag=${OPTARG};;
  269. j) verbose_IDE_flag=${OPTARG};;
  270. l) language_flag=${OPTARG};;
  271. m) mk404_flag=${OPTARG};;
  272. n) new_build_flag=${OPTARG};;
  273. o) output_flag=${OPTARG};;
  274. p) prusa_flag=${OPTARG};;
  275. v) variant_flag=${OPTARG};;
  276. x) board_mem_flag=${OPTARG};;
  277. y) board_flash_flag=${OPTARG};;
  278. ?) help_flag=1;;
  279. esac
  280. done
  281. #
  282. # '?' 'h' argument usage and help
  283. if [ "$help_flag" == "1" ] ; then
  284. echo "***************************************"
  285. echo "* PF-build.sh Version: 2.0.0-Build_57 *"
  286. echo "***************************************"
  287. echo "Arguments:"
  288. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  289. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  290. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  291. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy '$(tput setaf 2)3$(tput sgr0)' lite with Quad_HR '$(tput setaf 2)2$(tput sgr0)' fancy with Quad_HR"
  292. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  293. echo "$(tput setaf 2)-i$(tput sgr0) Arduino IDE version '$(tput setaf 2)1.8.5$(tput sgr0)', '$(tput setaf 2)1.8.13$(tput sgr0)'"
  294. echo "$(tput setaf 2)-j$(tput sgr0) Arduino IDE verbose output '$(tput setaf 2)0$(tput sgr0)', '$(tput setaf 2)1$(tput sgr0) active'"
  295. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  296. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  297. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  298. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  299. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  300. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  301. echo "$(tput setaf 2)-x$(tput sgr0) Board memory size '$(tput setaf 2)8$(tput sgr0)' or '$(tput setaf 2)64$(tput sgr0)' Kb."
  302. echo "$(tput setaf 2)-y$(tput sgr0) Board flash size '$(tput setaf 2)256$(tput sgr0)','$(tput setaf 2)384$(tput sgr0)','$(tput setaf 2)512$(tput sgr0)','$(tput setaf 2)1024$(tput sgr0)''$(tput setaf 2)32M$(tput sgr0)'"
  303. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  304. echo
  305. echo "Brief USAGE:"
  306. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-b] [-c] [-d] [-g] [-i] [-j] [-l] [-m] [-n] [-o] [-p ] -[v] [-x] [-y] [-h] [-?]"
  307. echo
  308. echo "Example:"
  309. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  310. echo " Will build all variants as multi language and final GOLD version"
  311. echo
  312. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  313. echo " Will build MK3S multi language final GOLD firmware "
  314. echo " with current commit count number and output extra information,"
  315. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  316. echo
  317. exit 6
  318. fi
  319. #Check if verbose_IDE is selected with argument '-j'
  320. if [ ! -z "$verbose_IDE_flag" ]; then
  321. if [ $verbose_IDE_flag == "1" ]; then
  322. verbose_IDE="1"
  323. elif [ $verbose_IDE_flag == "0" ]; then
  324. verbose_IDE="0"
  325. else
  326. echo "Only '0' and '1' are valid verbose_IDE values."
  327. exit
  328. fi
  329. else
  330. verbose_IDE="0"
  331. fi
  332. #Check if Build is selected with argument '-f'
  333. if [ ! -z "$board_flash_flag" ] ; then
  334. if [ "$board_flash_flag" == "256" ] ; then
  335. BOARD_FLASH="0x3FFFF"
  336. BOARD_maximum_size="253952"
  337. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  338. elif [ "$board_flash_flag" == "384" ] ; then
  339. BOARD_FLASH="0x5FFFF"
  340. BOARD_maximum_size="385024"
  341. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  342. elif [ "$board_flash_flag" == "512" ] ; then
  343. BOARD_FLASH="0x7FFFF"
  344. BOARD_maximum_size="516096"
  345. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  346. elif [ "$board_flash_flag" == "1024" ] ; then
  347. BOARD_FLASH="0xFFFFF"
  348. BOARD_maximum_size="1040384"
  349. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  350. elif [[ "$board_flash_flag" == "32M" || "$board_flash_flag" == "32768" ]] ; then
  351. BOARD_FLASH="0x1FFFFFF"
  352. BOARD_maximum_size="33546240"
  353. echo "Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  354. else
  355. echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
  356. exit 7
  357. fi
  358. fi
  359. #Check if Build is selected with argument '-x'
  360. if [ ! -z "$board_mem_flag" ] ; then
  361. if [ "$board_mem_flag" == "8" ] ; then
  362. BOARD_MEM="0x21FF"
  363. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  364. elif [ "$board_mem_flag" == "64" ] ; then
  365. BOARD_MEM="0xFFFF"
  366. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  367. else
  368. echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
  369. exit 8
  370. fi
  371. fi
  372. #Check if Arduino IDE version is correct
  373. if [ ! -z "$IDE_flag" ]; then
  374. if [[ "$IDE_flag" == "1.8.5" || "$IDE_flag" == "1.8.13" ]]; then
  375. ARDUINO_ENV="${IDE_flag}"
  376. else
  377. ARDUINO_ENV="1.8.5"
  378. fi
  379. else
  380. ARDUINO_ENV="1.8.5"
  381. fi
  382. #### Set build environment
  383. BUILD_ENV="1.0.6"
  384. BOARD="prusa_einsy_rambo"
  385. BOARD_PACKAGE_NAME="PrusaResearch"
  386. BOARD_VERSION="1.0.3"
  387. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  388. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  389. BOARD_FILENAME="prusa3dboards"
  390. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  391. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  392. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  393. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  394. LIB="PrusaLibrary"
  395. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  396. # List few useful data
  397. echo
  398. echo "Script path :" $SCRIPT_PATH
  399. echo "OS :" $OS
  400. echo "OS type :" $TARGET_OS
  401. echo ""
  402. echo "Arduino IDE :" $ARDUINO_ENV
  403. echo "Build env :" $BUILD_ENV
  404. echo "Board :" $BOARD
  405. if [ ! -z "$BOARD_FLASH" ] ; then
  406. echo "Board flash :" $BOARD_FLASH
  407. fi
  408. if [ ! -z "$BOARD_MEM" ] ; then
  409. echo "Board mem :" $BOARD_MEM
  410. fi
  411. echo "Package name:" $BOARD_PACKAGE_NAME
  412. echo "Board v. :" $BOARD_VERSION
  413. echo "Specific Lib:" $LIB
  414. echo ""
  415. #### Start prepare building environment
  416. #Check if build exists and creates it if not
  417. if [ ! -d "../PF-build-dl" ]; then
  418. mkdir ../PF-build-dl || exit 9
  419. fi
  420. cd ../PF-build-dl || exit 10
  421. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  422. # Check if PF-build-env-<version> exists and downloads + creates it if not
  423. # The build environment is based on the supported Arduino IDE portable version with some changes
  424. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  425. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  426. mkdir ../PF-build-env-$BUILD_ENV
  427. sleep 5
  428. fi
  429. # Download and extract supported Arduino IDE depending on OS
  430. # Windows
  431. if [ $TARGET_OS == "windows" ]; then
  432. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  433. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  434. sleep 2
  435. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  436. echo "$(tput sgr 0)"
  437. fi
  438. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  439. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  440. sleep 2
  441. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  442. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  443. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  444. echo "$(tput sgr0)"
  445. fi
  446. fi
  447. # Linux
  448. if [ $TARGET_OS == "linux" ]; then
  449. # 32 or 64 bit version
  450. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  451. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  452. sleep 2
  453. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  454. echo "$(tput sgr 0)"
  455. fi
  456. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  457. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  458. sleep 2
  459. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  460. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  461. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  462. echo "$(tput sgr0)"
  463. fi
  464. fi
  465. # Make Arduino IDE portable
  466. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  467. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  468. fi
  469. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  470. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  471. fi
  472. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  473. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  474. fi
  475. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  476. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  477. fi
  478. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  479. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  480. fi
  481. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  482. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  483. fi
  484. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  485. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  486. fi
  487. # Change Arduino IDE preferences
  488. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  489. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  490. sleep 2
  491. echo "update.check"
  492. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  493. echo "board"
  494. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  495. echo "editor.linenumbers"
  496. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  497. echo "boardsmanager.additional.urls"
  498. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  499. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  500. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  501. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  502. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  503. echo "$(tput sgr0)"
  504. fi
  505. # Download and extract Prusa Firmware related parts
  506. # Download and extract PrusaResearchRambo board
  507. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  508. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  509. sleep 2
  510. wget $BOARD_FILE_URL || exit 10
  511. fi
  512. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  513. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  514. sleep 2
  515. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  516. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  517. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  518. fi
  519. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  520. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  521. fi
  522. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  523. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  524. fi
  525. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  526. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  527. fi
  528. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  529. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  530. echo "$(tput sgr 0)"
  531. fi
  532. # Download and extract Prusa Firmware specific library files
  533. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  534. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  535. sleep 2
  536. wget $PF_BUILD_FILE_URL || exit 12
  537. echo "$(tput sgr 0)"
  538. fi
  539. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  540. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  541. sleep 2
  542. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  543. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  544. echo "$(tput sgr0)"
  545. fi
  546. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  547. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  548. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  549. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  550. sleep 2
  551. fi
  552. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  553. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  554. sleep 2
  555. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  556. sleep 2
  557. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  558. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  559. echo "$(tput sgr0)"
  560. fi
  561. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  562. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  563. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  564. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  565. sleep 2
  566. echo "$(tput sgr0)"
  567. exit 14
  568. fi
  569. #### End prepare building
  570. #### Start
  571. cd $SCRIPT_PATH
  572. # Check if git is available
  573. if type git > /dev/null; then
  574. git_available="1"
  575. fi
  576. #
  577. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  578. if [ -z "$variant_flag" ] ; then
  579. # Select which variant of the Prusa Firmware will be compiled, like
  580. PS3="Select a variant: "
  581. while IFS= read -r -d $'\0' f; do
  582. options[i++]="$f"
  583. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  584. select opt in "${options[@]}" "All" "Quit"; do
  585. case $opt in
  586. *.h)
  587. VARIANT=$(basename "$opt" ".h")
  588. VARIANTS[i++]="$opt"
  589. break
  590. ;;
  591. "All")
  592. VARIANT="All"
  593. VARIANTS=${options[*]}
  594. break
  595. ;;
  596. "Quit")
  597. echo "You chose to stop"
  598. exit 22
  599. ;;
  600. *)
  601. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  602. ;;
  603. esac
  604. done
  605. else
  606. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  607. VARIANTS=$variant_flag
  608. elif [ "$variant_flag" == "All" ] ; then
  609. while IFS= read -r -d $'\0' f; do
  610. options[i++]="$f"
  611. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  612. VARIANT="All"
  613. VARIANTS=${options[*]}
  614. else
  615. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  616. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  617. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  618. echo "$(tput sgr0)"
  619. exit 23
  620. fi
  621. fi
  622. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  623. #Check default language mode
  624. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  625. if [ -z "$language_flag" ] ; then
  626. PS3="Select a language: "
  627. echo
  628. echo "Which lang-build do you want?"
  629. select yn in "Multi languages" "English only"; do
  630. case $yn in
  631. "Multi languages")
  632. LANGUAGES="ALL"
  633. break
  634. ;;
  635. "English only")
  636. LANGUAGES="EN_ONLY"
  637. break
  638. ;;
  639. *)
  640. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  641. ;;
  642. esac
  643. done
  644. else
  645. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  646. LANGUAGES=$language_flag
  647. else
  648. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  649. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  650. exit 24
  651. fi
  652. fi
  653. #Check if DEV_STATUS is selected via argument '-d'
  654. if [ ! -z "$devel_flag" ] ; then
  655. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  656. DEV_STATUS_SELECTED=$devel_flag
  657. elif [[ "$devel_flag" == "atmega404" || "$devel_flag" == "atmega404_no_bootloader" ]] ; then
  658. MK404_DEBUG=$devel_flag
  659. else
  660. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  661. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  662. exit 25
  663. fi
  664. fi
  665. #Check if Build is selected via argument '-b'
  666. if [ ! -z "$build_flag" ] ; then
  667. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  668. echo "Build changed to $build_flag"
  669. BUILD=$(git rev-list --count HEAD)
  670. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  671. BUILD=$build_flag
  672. else
  673. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  674. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  675. exit 26
  676. fi
  677. echo "New Build number is: $BUILD"
  678. fi
  679. # check if script has been started with arguments
  680. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  681. OUTPUT=1
  682. else
  683. OUTPUT=0
  684. fi
  685. #echo "Output is:" $OUTPUT
  686. #Check git branch has changed
  687. if [ ! -z "git_available" ]; then
  688. BRANCH=""
  689. CLEAN_PF_FW_BUILD=0
  690. else
  691. BRANCH=$(git branch --show-current)
  692. echo "Current branch is:" $BRANCH
  693. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  694. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  695. echo "created PF-build.branch file"
  696. else
  697. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  698. echo "Previous branch was:" $PRE_BRANCH
  699. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  700. CLEAN_PF_FW_BUILD=1
  701. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  702. fi
  703. fi
  704. fi
  705. #Set BUILD_ENV_PATH
  706. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  707. BUILD_ENV_PATH="$( pwd -P )"
  708. cd ../..
  709. #Checkif BUILD_PATH exists and if not creates it
  710. if [ ! -d "Prusa-Firmware-build" ]; then
  711. mkdir Prusa-Firmware-build || exit 28
  712. fi
  713. #Set the BUILD_PATH for Arduino IDE
  714. cd Prusa-Firmware-build || exit 29
  715. BUILD_PATH="$( pwd -P )"
  716. #Check git branch has changed
  717. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  718. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  719. rm -r *
  720. else
  721. echo "Nothing to clean up"
  722. fi
  723. for v in ${VARIANTS[*]}
  724. do
  725. VARIANT=$(basename "$v" ".h")
  726. MK404_PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  727. # Find firmware version in Configuration.h file and use it to generate the hex filename
  728. FW_MAJOR=$(grep --max-count=1 "\bFW_MAJOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  729. FW_MINOR=$(grep --max-count=1 "\bFW_MINOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  730. FW_REVISION=$(grep --max-count=1 "\bFW_REVISION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  731. FW="$FW_MAJOR$FW_MINOR$FW_REVISION"
  732. #FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  733. if [ -z "$BUILD" ] ; then
  734. # Find build version in Configuration.h file and use it to generate the hex filename
  735. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  736. else
  737. # Find and replace build version in Configuration.h file
  738. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  739. echo "Original build number: $BUILD_ORG"
  740. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  741. fi
  742. # Check if the motherboard is an EINSY and if so only one hex file will generated
  743. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  744. # Check development status
  745. FW_FLAV=$(grep --max-count=1 "//#define FW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h|cut -d ' ' -f1)
  746. if [[ "$FW_FLAV" != "//#define" ]] ; then
  747. FW_FLAVOR=$(grep --max-count=1 "\bFW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  748. FW_FLAVERSION=$(grep --max-count=1 "\bFW_FLAVERSION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  749. if [[ "$FW_FLAVOR" != "//#define FW_FLAVOR" ]] ; then
  750. FW="$FW-$FW_FLAVOR"
  751. DEV_CHECK="$FW_FLAVOR"
  752. if [ ! -z "$FW_FLAVERSION" ] ; then
  753. FW="$FW$FW_FLAVERSION"
  754. fi
  755. fi
  756. fi
  757. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  758. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  759. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  760. DEV_STATUS="RC"
  761. elif [[ "$DEV_CHECK" == *"ALPHA"* ]]; then
  762. DEV_STATUS="ALPHA"
  763. elif [[ "$DEV_CHECK" == *"BETA"* ]]; then
  764. DEV_STATUS="BETA"
  765. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  766. DEV_STATUS="DEVEL"
  767. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  768. DEV_STATUS="DEBUG"
  769. else
  770. DEV_STATUS="UNKNOWN"
  771. echo
  772. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  773. PS3="Select YES only if source code is tested and trusted: "
  774. select yn in "Yes" "No"; do
  775. case $yn in
  776. Yes)
  777. DEV_STATUS="GOLD"
  778. DEV_STATUS_SELECTED="GOLD"
  779. break
  780. ;;
  781. No)
  782. DEV_STATUS="UNKNOWN"
  783. DEV_STATUS_SELECTED="UNKNOWN"
  784. break
  785. ;;
  786. *)
  787. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  788. ;;
  789. esac
  790. done
  791. fi
  792. else
  793. DEV_STATUS=$DEV_STATUS_SELECTED
  794. fi
  795. #Prepare hex files folders
  796. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  797. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  798. fi
  799. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  800. if [ "$BOARD" != "prusa_einsy_rambo" ]; then
  801. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD" ]; then
  802. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD || exit 28
  803. fi
  804. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$BOARD"
  805. fi
  806. #Check if exactly the same hexfile already exists
  807. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  808. echo ""
  809. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  810. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  811. if [ $OUTPUT == "1" ] ; then
  812. read -t 10 -p "Press Enter to continue..."
  813. fi
  814. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  815. echo ""
  816. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  817. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  818. if [ $OUTPUT == "1" ] ; then
  819. read -t 10 -p "Press Enter to continue..."
  820. fi
  821. fi
  822. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  823. echo ""
  824. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  825. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  826. if [ $OUTPUT == "1" ] ; then
  827. read -t 10 -p "Press Enter to continue..."
  828. fi
  829. fi
  830. #List some useful data
  831. echo "$(tput setaf 2)$(tput setab 7) "
  832. echo "Printer :" $MK404_PRINTER
  833. echo "Variant :" $VARIANT
  834. echo "Firmware :" $FW
  835. echo "Build # :" $BUILD
  836. echo "Dev Check :" $DEV_CHECK
  837. echo "DEV Status :" $DEV_STATUS
  838. echo "Motherboard:" $MOTHERBOARD
  839. echo "Board flash:" $BOARD_FLASH
  840. echo "Board mem :" $BOARD_MEM
  841. echo "Languages :" $LANGUAGES
  842. echo "Hex-file Folder:" $OUTPUT_FOLDER
  843. echo "$(tput sgr0)"
  844. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  845. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  846. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  847. else
  848. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  849. if [ $OUTPUT == "1" ] ; then
  850. read -t 10 -p "Press Enter to continue..."
  851. fi
  852. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  853. fi
  854. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  855. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  856. # set FW_REPOSITORY
  857. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  858. #Prepare English only or multi-language version to be build
  859. if [ $LANGUAGES == "EN_ONLY" ]; then
  860. echo " "
  861. echo "English only language firmware will be built"
  862. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  863. echo " "
  864. else
  865. echo " "
  866. echo "Multi-language firmware will be built"
  867. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  868. echo " "
  869. fi
  870. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  871. #if [ $TARGET_OS == "windows" ]; then
  872. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  873. #fi
  874. #New fresh PF-Firmware-build
  875. if [ "$new_build_flag" == "1" ]; then
  876. rm -r -f $BUILD_PATH/* || exit 54
  877. fi
  878. # Prepare Board mem and flash modifications
  879. ## Check board mem size
  880. CURRENT_BOARD_MEM=$(grep "#define RAMEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  881. if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
  882. echo "Board mem has been already modified or not reset"
  883. echo "Current:" $CURRENT_BOARD_MEM
  884. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  885. select yn in "Yes" "No"; do
  886. case $yn in
  887. Yes)
  888. echo "Resetting board mem size"
  889. sed -i -- "s/^#define RAMEND .*$/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  890. break
  891. ;;
  892. *)
  893. echo "Continuing with modified mem size"
  894. break
  895. ;;
  896. esac
  897. done
  898. fi
  899. ## Modify board mem size
  900. if [[ ! -z $BOARD_MEM && "$BOARD_MEM" != "0x21FF" ]] ; then
  901. echo "$(tput setaf 3)Modifying board memory size (hex):$(tput sgr 0)"
  902. echo "Old:" $CURRENT_BOARD_MEM
  903. echo "New:" $BOARD_MEM
  904. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  905. echo ""
  906. sed -i -- "s/^#define RAMEND 0x21FF/#define RAMEND ${BOARD_MEM}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  907. fi
  908. ## Check board flash size
  909. CURRENT_BOARD_FLASH=$(grep "#define FLASHEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  910. CURRENT_BOARD_maximum_size=$(grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt |cut -d '=' -f2|tr -d $'\n')
  911. if [[ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ]] ; then
  912. echo "Board flash has been already modified or not reset"
  913. echo "Current flash size:" $CURRENT_BOARD_FLASH
  914. echo "Current max. size:" $CURRENT_BOARD_maximum_size
  915. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  916. select yn in "Yes" "No"; do
  917. case $yn in
  918. Yes)
  919. echo "$(tput setaf 1)Resetting board flash size$(tput sgr 0)"
  920. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  921. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  922. break
  923. ;;
  924. *)
  925. echo "$(tput setaf 3)Continuing with modified flash size$(tput sgr 0)"
  926. break
  927. ;;
  928. esac
  929. done
  930. fi
  931. ## Modify boad flash size
  932. if [[ ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]] ; then
  933. echo "Modifying board flash size (hex):"
  934. echo "Old flash size:" $CURRENT_BOARD_FLASH
  935. echo "New flash size:" $BOARD_FLASH
  936. echo "Old max. size:" $CURRENT_BOARD_maximum_size
  937. echo "New max. size:" $BOARD_maximum_size
  938. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  939. sed -i -- "s/^#define FLASHEND .*/#define FLASHEND ${BOARD_FLASH}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  940. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=${BOARD_maximum_size}/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  941. fi
  942. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  943. # if [ $TARGET_OS == "windows" ]; then
  944. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  945. # fi
  946. #### End of Prepare building
  947. #### Start building
  948. export ARDUINO=$BUILD_ENV_PATH
  949. #echo $BUILD_ENV_PATH
  950. #export BUILDER=$ARDUINO/arduino-builder
  951. echo
  952. #read -t 5 -p "Press Enter..."
  953. echo
  954. echo "Start to build Prusa Firmware ..."
  955. echo "Using variant $VARIANT$(tput setaf 3)"
  956. if [ $OUTPUT == "1" ] ; then
  957. sleep 2
  958. fi
  959. if [ $verbose_IDE == "1" ]; then
  960. $BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  961. fi
  962. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all -verbose=$verbose_IDE $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  963. echo "$(tput sgr 0)"
  964. if [ $LANGUAGES == "ALL" ]; then
  965. echo "$(tput setaf 2)"
  966. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  967. echo "$(tput sgr 0)"
  968. if [ $OUTPUT == "1" ] ; then
  969. sleep 2
  970. fi
  971. cd $SCRIPT_PATH/lang
  972. echo "$(tput setaf 3)"
  973. ./config.sh || exit 43
  974. echo "$(tput sgr 0)"
  975. # Check if previous languages and firmware build exist and if so clean them up
  976. if [ -f "lang_en.tmp" ]; then
  977. echo ""
  978. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  979. if [ $OUTPUT == "1" ] ; then
  980. read -t 10 -p "Press Enter to continue..."
  981. fi
  982. echo "$(tput setaf 3)"
  983. ./lang-clean.sh
  984. echo "$(tput sgr 0)"
  985. fi
  986. if [ -f "progmem.out" ]; then
  987. echo ""
  988. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  989. if [ $OUTPUT == "1" ] ; then
  990. read -t 10 -p "Press Enter to continue..."
  991. fi
  992. echo "$(tput setaf 3)"
  993. ./fw-clean.sh
  994. echo "$(tput sgr 0)"
  995. fi
  996. # build languages
  997. echo "$(tput setaf 3)"
  998. ./lang-build.sh || exit 44
  999. # build community languages
  1000. ./lang-community.sh || exit 45
  1001. # Combine compiled firmware with languages
  1002. ./fw-build.sh || exit 46
  1003. cp not_tran.txt not_tran_$VARIANT.txt
  1004. cp not_used.txt not_used_$VARIANT.txt
  1005. echo "$(tput sgr 0)"
  1006. # Check if the motherboard is an EINSY and if so only one hex file will generated
  1007. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  1008. # If the motherboard is an EINSY just copy one hexfile
  1009. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  1010. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  1011. # End of "lang.bin" for MK3 and MK3S copy
  1012. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1013. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1014. else
  1015. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  1016. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  1017. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  1018. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  1019. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  1020. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  1021. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  1022. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
  1023. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1024. if [ $TARGET_OS == "windows" ]; then
  1025. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1026. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1027. elif [ $TARGET_OS == "linux" ]; then
  1028. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  1029. if [ ! -z "$mk404_flag" ]; then
  1030. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1031. fi
  1032. # End of MK2, MK2.5, MK2.5S firmware copy
  1033. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1034. fi
  1035. fi
  1036. # Cleanup after build
  1037. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  1038. echo "$(tput setaf 3)"
  1039. ./fw-clean.sh || exit 51
  1040. ./lang-clean.sh || exit 52
  1041. echo "$(tput sgr 0)"
  1042. fi
  1043. else
  1044. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  1045. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 47
  1046. echo "$(tput setaf 2)Copying English only elf file to PF-build-hex folder$(tput sgr 0)"
  1047. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.elf || exit 47
  1048. fi
  1049. # Cleanup Firmware
  1050. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  1051. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  1052. fi
  1053. # Delete dupblicates
  1054. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  1055. then
  1056. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  1057. fi
  1058. # MK2 not supported in this branch
  1059. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  1060. then
  1061. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  1062. fi
  1063. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  1064. then
  1065. rm $SCRIPT_PATH/lang/not_tran.txt
  1066. fi
  1067. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  1068. then
  1069. rm $SCRIPT_PATH/lang/not_used.txt
  1070. fi
  1071. #New fresh PF-Firmware-build
  1072. if [ "$new_build_flag" == "1" ]; then
  1073. rm -r -f $BUILD_PATH/* || exit 54
  1074. fi
  1075. # Restore files to previous state
  1076. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  1077. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  1078. if [ ! -z "$BUILD_ORG" ] ; then
  1079. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  1080. fi
  1081. echo $MULTI_LANGUAGE_CHECK
  1082. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  1083. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1084. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1085. if [ $OUTPUT == "1" ] ; then
  1086. sleep 5
  1087. fi
  1088. # Restore build env files to previous state
  1089. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1090. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  1091. sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1092. done
  1093. # Switch to hex path and list build files
  1094. cd $SCRIPT_PATH
  1095. echo "$(tput setaf 2) "
  1096. echo " "
  1097. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  1098. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  1099. #### End building
  1100. #### MK404 Simulator
  1101. # Check/compile MK404 sim
  1102. if [ ! -z "$mk404_flag" ]; then
  1103. # For Prusa MK2, MK2.5/S
  1104. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  1105. MK404_PRINTER="${MK404_PRINTER}_mR13"
  1106. else
  1107. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  1108. MK404_PRINTER="${MK404_PRINTER}MMU2"
  1109. fi
  1110. fi
  1111. # Run MK404 with 'debugcore' and/or 'bootloader-file'
  1112. if [ ! -z "$board_mem_flag" ]; then
  1113. MK404_options="-x $board_mem_flag"
  1114. fi
  1115. if [ ! -z "$board_flash_flag" ]; then
  1116. MK404_options="${MK404_options} -y $board_flash_flag"
  1117. fi
  1118. # Run MK404 with grafics
  1119. if [ ! -z "$graphics_flag" ]; then
  1120. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "2" || "$graphics_flag" == "3" || "$graphics_flag" == "4" ]]; then
  1121. MK404_options="${MK404_options} -g $graphics_flag"
  1122. else
  1123. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  1124. fi
  1125. fi
  1126. # Output some useful data
  1127. echo "Printer: $MK404_PRINTER"
  1128. echo "Options: $MK404_options"
  1129. echo ""
  1130. read -t 5 -p "Press $(tput setaf 2)Enter$(tput sgr 0) to start MK404"
  1131. echo ""
  1132. # Change to MK404 build folder
  1133. #cd ../MK404/master/build
  1134. #Decide which hex file to use EN_ONLY or Multi language
  1135. if [ "$LANGUAGES" == "ALL" ]; then
  1136. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1137. else
  1138. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  1139. fi
  1140. # Start MK404
  1141. # default with serial output and terminal to manipulate it via terminal
  1142. #echo ""
  1143. #echo "./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file"
  1144. #sleep 5
  1145. #./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  1146. echo ""
  1147. echo "./MK404-build.sh -m $mk404_flag -p $MK404_PRINTER $MK404_options -f $MK404_firmware_file"
  1148. sleep 5
  1149. ./MK404-build.sh -m $mk404_flag -p $MK404_PRINTER $MK404_options -f $MK404_firmware_file|| exit 61
  1150. fi
  1151. #### End of MK404 Simulator